// eslint-disable-next-line import/no-extraneous-dependencies
import React, { FC } from 'react';
// eslint-disable-next-line import/no-extraneous-dependencies
import styled from 'styled-components';

// eslint-disable-next-line @nrwl/nx/enforce-module-boundaries
import { Cloud } from '@clds/icon';

import { theme } from './ThemeMixins.theme';

export const Button = styled.div`
  height: ${theme.button.size};
  width: ${theme.button.size};
`;

const Content = styled.div``;

const Root = styled.div`
  display: inline-flex;
  align-items: center;
  cursor: pointer;

  color: ${theme.text.color};

  background-color: ${theme.background};

  &,
  ${Button} {
    border-radius: ${theme.border.radius};
  }
  ${Button} {
    background-color: ${theme.button.background.color};
    border-bottom-right-radius: 0;
    border-top-right-radius: 0;
    display: flex;
    justify-content: center;
    align-items: center;
    svg path {
      fill: ${theme.button.icon.color};
    }
  }
  ${Content} {
    padding: 0 ${theme.text.padding};
  }
`;

export const ThemeMixins: FC = ({ children, ...rest }) => (
  <Root {...rest}>
    <Button>
      <Cloud size="md" />
    </Button>
    <Content>{children}</Content>
  </Root>
);
