// eslint-disable-next-line import/no-extraneous-dependencies
import { mix } from 'polished';
// eslint-disable-next-line import/no-extraneous-dependencies
import { ComponentProps, FC } from 'react';
// eslint-disable-next-line import/no-extraneous-dependencies
import styled from 'styled-components';

// eslint-disable-next-line import/no-extraneous-dependencies
import { combineValues, globalTheme } from '@clds/component-theme';

import { Button, ThemeMixins } from './ThemeMixins';
import { theme } from './ThemeMixins.theme';

export interface Props extends ComponentProps<typeof ThemeMixins> {
  selected?: boolean;
}

export const ThemeMixinsWithCombine = styled<FC<Props>>(ThemeMixins)`
  margin: ${globalTheme.spacing.md};
  &:hover {
    background-color: ${combineValues(
      theme.button.background.color,
      theme.button.icon.color,
      theme.text.color,
      (v1, v2, v3, props) => mix(0.9, props.selected ? v1 : v2, v3),
    )};
    ${Button} {
      background-color: ${combineValues(
        theme.button.background.color,
        theme.background,
        (v1, v2) => mix(0.8, v1, v2),
      )};
    }
  }
  // combineValues with theme and global mixins
  box-shadow: 0 2px 5px 0
    ${combineValues(
      theme.background,
      globalTheme.palette.primary,
      (background, primary) => mix(0.5, background, primary),
    )};

  // combineValues on parent nodes
  background-color: ${combineValues(theme.button, (button, props) =>
    props.selected ? button.background.color : button.icon.color,
  )};
  color: ${combineValues(theme, (theme, props) =>
    props.selected ? theme.button.icon.color : theme.text.color,
  )};
`;
