// eslint-disable-next-line import/no-extraneous-dependencies
import { rgba } from 'polished';

// eslint-disable-next-line import/no-extraneous-dependencies
import { combineValues, createTheme, globalTheme } from '@clds/component-theme';

const { palette, spacing, radius } = globalTheme;

export const theme = createTheme({
  hover: {
    background: combineValues(palette.primary, (color) => rgba(color, 0.06)),
  },
  pill: {
    primary: {
      button: {
        color: palette.primary,
      },
      border: {
        radius: '100px',
      },
      background: palette.surface,
      size: spacing.xxl,
    },
    secondary: {
      button: {
        color: palette.secondary,
      },
      border: {
        radius: '100px',
      },
      background: palette.surface,
      size: spacing.xl,
    },
  },
  solid: {
    primary: {
      button: {
        color: palette.primary,
      },
      border: {
        radius: radius.lg,
      },
      background: palette.surface,
      size: spacing.xxl,
    },
    secondary: {
      button: {
        color: palette.secondary,
      },
      border: {
        radius: radius.lg,
      },
      background: palette.surface,
      size: spacing.xl,
    },
  },
});
